<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="80px">
      <el-form-item :label="tLang('device', '配置名称')" prop="name">
        <el-input v-model="queryParams.name" :placeholder="tLang('common', '请输入') + tLang('device', '配置名称')" clearable
          @keyup.enter="handleQuery" />
      </el-form-item>
      
      <el-form-item>
        <el-button type="primary" icon="search" size="mini" @click="handleQuery">{{ tLang('common', '搜索') }}</el-button>
        <el-button icon="refresh" size="mini" @click="resetQuery">{{ tLang('common', '重置') }}</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="plus" size="mini" @click="handleAdd" v-hasPermi="['pms:devConfig:add']">{{
      $t('common.新增') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['pms:devConfig:edit']">{{ $t('common.修改') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['pms:devConfig:remove']">{{ $t('common.删除') }}</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button type="warning" plain icon="download" size="mini" @click="handleExport"
          v-hasPermi="['device:devConfig:export']">导出</el-button>
      </el-col> -->
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="deviceList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column type="index" :label="$t('common.序号')" width="60" align="center" />
      <el-table-column :label="tLang('device', '配置名称')" align="center" v-if="columns[0].visible" prop="name" />
      <el-table-column :label="tLang('common', '操作')" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-tooltip :content="tLang('common', '修改')" placement="top" v-if="scope.row.userId !== 1">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
              v-hasPermi="['pms:devConfig:edit']"></el-button>
          </el-tooltip>
          <el-tooltip :content="tLang('common', '删除')" placement="top" v-if="scope.row.userId !== 1">
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
              v-hasPermi="['pms:devConfig:remove']"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>

    <div class="pagination">
      <el-pagination :hide-on-single-page="true" v-model:current-page="queryParams.pageNum"
        v-model:page-size="queryParams.pageSize" :page-sizes="[25, 50, 100, 150]"
        layout="total, sizes, prev, pager, next, jumper" :total="total" @size-change="getList"
        @current-change="getList" />
    </div>

    <!-- 添加或修改设备信息对话框 -->
    <el-dialog :title="title" v-model="open" width="800px" append-to-body>
      <el-form ref="formRef" :model="form" :rules="rules"  label-width="150px">
        <!-- <el-form-item :label="tLang('device', '配置编码')" prop="code">
          <el-input v-model="form.code" :placeholder="tLang('common', '请输入') + tLang('device', '配置编码')" />
        </el-form-item> -->
        <el-form-item :label="tLang('device', '配置名称')" prop="name">
          <el-input v-model="form.name" :placeholder="tLang('common', '请输入') + tLang('device', '配置名称')" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">{{ tLang('common', '确 定') }}</el-button>
          <el-button @click="cancel">{{ tLang('common', '取 消') }}</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup>
import { ref, reactive, watch, onMounted } from 'vue'
import { listDeviceConfig, getDeviceConfig, addDeviceConfig, updateDeviceConfig, delDeviceConfig } from "@/api/pms/device.js";
const { proxy } = getCurrentInstance();
// 遮罩层
let loading = ref(true)
// 选中数组
let ids = ref([])
// 非单个禁用
let single = ref(true)
// 非多个禁用
let multiple = ref(true)
// 显示搜索条件
let showSearch = ref(false)
// 总条数
let total = ref(0)
// 设备信息表格数据
let deviceList = ref([])
// 弹出层标题
let title = ref("")
// 是否显示弹出层
let open = ref(false)
let infoDialog = ref(false)
let deviceinfo = ref({})
// 查询参数
let queryParams = reactive({
  pageNum: 1,
  pageSize: 10,
  name: null,
})
// 表单参数
let form = ref({})
const formRef = ref(null)
// 表单校验
let rules = ref({
  name: [
    {
      required: true,
      message: proxy.tLang('common', '请输入') + proxy.tLang('device', '配置名称'),
      trigger: 'blur',
    },
  ],
})
// 列显隐信息
const columns = ref([
  { key: 0, label: proxy.tLang('device', `设备名称`), visible: true },
]);
/** 查询设备配置信息列表 */
function getList() {
  loading.value = true;
  listDeviceConfig(queryParams).then(response => {
    deviceList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
  loading.value = false;
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}
// 表单重置
function reset() {
  form.value = {
    name: null,
    code: null
  };
  //resetForm("form");
}

//** 搜索按钮操作 */
function handleQuery() {
  queryParams.pageNum = 1;
  getList();
}
/** 重置按钮操作 */
function resetQuery() {
  queryParams.pageNum = 1
  queryParams.pageSize = 10
  queryParams.name = null

  handleQuery();
}
// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.code)
  single.value = selection.length !== 1
  multiple.value = !selection.length
}

/**详情按钮操作 */
function handleInfo(row) {
  deviceinfo.value = row
  infoDialog.value = true
}
/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = proxy.tLang('common', '添加') + ' ' + proxy.tLang('device', '设备配置');
}
/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const id = row.code || ids.value
  getDeviceConfig(id).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = proxy.tLang('common', '修改') + ' ' + proxy.tLang('device', '设备配置');
  });
}
/** 提交按钮 */
function submitForm() {
  formRef.value.validate(valid => {
    if (valid) {
      if (form.value.code != null) {
        updateDeviceConfig(form.value).then(response => {
          proxy.$modal.msgSuccess(proxy.tLang('common', '修改成功'));
          open.value = false;
          getList();
        });
      } else {
        addDeviceConfig(form.value).then(response => {
          proxy.$modal.msgSuccess(proxy.tLang('common', '新增成功'));
          open.value = false;
          getList();
        });
      }
    }
  });
}
/** 删除按钮操作 */
function handleDelete(row) {
  const id = row.code || ids.value;
  proxy.$modal.confirm(proxy.tLang('tip', '确定删除选中记录？') + ` [${id}]`).then(function () {
    return delDeviceConfig(id);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess(proxy.tLang('common', '删除成功'));
  }).catch(() => { });
}
/** 导出按钮操作 */
function handleExport() {
  this.download('casm/device/export', {
    ...queryParams
  }, `device_${new Date().getTime()}.xlsx`)
}

onMounted(() => {
  getList();
})
</script>

<style lang="scss" scoped>
.demo-form-inline :deep(.el-input) {
  --el-input-width: 220px;
}

.demo-form-inlinee :deep(.el-select) {
  --el-select-width: 220px;
}

.pagination {
  width: 100%;
  margin: 10px;
  display: flex;
  justify-content: center;
  align-items: center;
}
</style>
